import { deserialize, serialize } from "@dao-xyz/borsh";
import stringify from "json-stringify-deterministic";
const encoder = new TextEncoder();
const decoder = new TextDecoder();
export const JSON_ENCODING = {
    encoder: (obj) => {
        return new Uint8Array(encoder.encode(stringify(obj)));
    },
    decoder: (bytes) => {
        return JSON.parse(decoder.decode(bytes).toString());
    },
};
export const BORSH_ENCODING = (clazz) => {
    return {
        decoder: (bytes) => deserialize(bytes, clazz),
        encoder: (data) => serialize(data),
    };
};
//# sourceMappingURL=encoding.js.map