import { Entry } from "./entry.js";
import { ISortFunction } from "./log-sorting.js";
export declare class HeadsIndex<T> {
    _index: Map<string, Entry<T>>;
    _sortFn: ISortFunction;
    _gids: Map<string, number>;
    constructor(properties: {
        sortFn: ISortFunction;
        entries: Map<string, Entry<T>>;
    });
    get index(): Map<string, Entry<T>>;
    get gids(): Map<string, number>;
    reset(entries: Map<string, Entry<T>> | Entry<T>[]): void;
    get(hash: string): Entry<T> | undefined;
    put(entry: Entry<any>): void;
    del(entry: Entry<any>): {
        removed: boolean;
        lastWithGid: boolean;
    };
    /**
     * Returns an array of heads.
     * Dont use this anywhere where performance matters
     * @returns {Array<Entry<T>>}
     */
    get array(): Entry<T>[];
}
