import { Entry } from "./entry";
import { ISortFunction } from "./log-sorting";
import yallist from "yallist";
export declare class Values<T> {
    /**
     * Keep track of sorted elements in descending sort order (i.e. newest elements)
     */
    private _values;
    _sortFn: ISortFunction;
    _byteLength: number;
    constructor(sortFn: ISortFunction, entries?: Entry<T>[]);
    toArray(): Entry<T>[];
    get head(): yallist.Node<Entry<T>> | null;
    get tail(): yallist.Node<Entry<T>> | null;
    get length(): number;
    put(value: Entry<T>): void;
    delete(value: Entry<T> | string): void;
    deleteNode(node: yallist.Node<Entry<T>>): void;
    pop(): Entry<T> | undefined;
    getLowerIndex(value: Entry<T>): void;
    get byteLength(): number;
}
